'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require('yylib-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 订阅
 * @author maxx4
 */
var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


var uiMeta = {
    name: 'subsbutton',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    //------------订阅按钮配置------------//
    field('type', 'error', PropTypes.oneOf(['primary', 'success', 'info', 'warning', 'error', '']), false, '设置按钮类型，可选值为 primary|success|info|warning|error 或者不设'), field('buttonText', '订阅', PropTypes.string, false, '设置按钮的文本'), field('icon', 'warning', PropTypes.string, false, '设置按钮的图标类型'), field('visible', true, PropTypes.bool, false, '设置按钮是否显示'), field('disabled', false, PropTypes.bool, false, '设置按钮是否禁用'), field('ghost', true, PropTypes.bool, false, '设置按钮为不填充形态')]
};

var SubsButton = _yylibUi.YYClass.create({
    uiMeta: uiMeta,
    displayName: 'SubsButton',

    getInitialState: function getInitialState() {
        return {
            showModal: false,
            subsType: "week", //默认周订阅
            subsColumn: [] //订阅字段
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {},
    onClick: function onClick() {
        var _props = this.props,
            serverUrl = _props.serverUrl,
            columns = _props.columns;

        if (!serverUrl || !columns) {
            _yylibUi.YYMessage.error("缺少必要参数");
            return;
        }
        this.setState({ showModal: true });
    },
    onCancel: function onCancel() {
        this.setState({ showModal: false });
    },
    onRadioChange: function onRadioChange(e) {
        var subsType = e.target.value;
        this.setState({
            subsType: subsType
        });
    },
    onCheckChange: function onCheckChange(e) {
        if (!e || e.length === 0) {
            this.setState({ subsColumn: [] });
        }
        var columns = this.props.columns;

        var _subsColumn = [];
        e.map(function (item) {
            var filterC = columns.filter(function (c) {
                return c.value === item;
            });
            if (filterC && filterC.length > 0) {
                _subsColumn.push(filterC[0]);
            }
        });
        this.setState({ subsColumn: _subsColumn });
    },
    render: function render() {
        var _props2 = this.props,
            visible = _props2.visible,
            type = _props2.type,
            icon = _props2.icon,
            buttonText = _props2.buttonText,
            disabled = _props2.disabled,
            ghost = _props2.ghost,
            columns = _props2.columns;
        var _state = this.state,
            showModal = _state.showModal,
            subsType = _state.subsType;

        var width = document.documentElement.clientWidth * 0.8;
        var height = document.documentElement.clientHeight * 0.6;
        return _react2.default.createElement(
            'div',
            { className: this.className(), style: { display: 'inline-block' } },
            _react2.default.createElement(
                _yylibUi.YYButton,
                { icon: icon, type: type, ghost: ghost, disabled: disabled, visible: visible,
                    onClick: this.onClick },
                buttonText
            ),
            showModal === true ? _react2.default.createElement(
                _yylibUi.YYModal,
                { title: '订阅设置', visible: showModal, width: width,
                    maskClosable: false, bodyStyle: { padding: 0 },
                    onCancel: this.onCancel, style: { top: height * 0.1 }, onOk: this.onOk },
                _react2.default.createElement(
                    'div',
                    { style: { margin: "10px 20px" } },
                    _react2.default.createElement(
                        'div',
                        { style: {
                                marginBottom: "10px",
                                fontWeight: "700"
                            } },
                        '\u8BA2\u9605\u5468\u671F\uFF1A'
                    ),
                    _react2.default.createElement(
                        _yylibUi.YYRadioGroup,
                        { onChange: this.onRadioChange, defaultValue: subsType, value: subsType },
                        _react2.default.createElement(
                            _yylibUi.YYRadio,
                            { value: "week", uititle: "周订阅", uikey: "week" },
                            '\u5468\u8BA2\u9605'
                        ),
                        _react2.default.createElement(
                            _yylibUi.YYRadio,
                            { value: "month", uititle: "月订阅", month: "month" },
                            '\u6708\u8BA2\u9605'
                        )
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { style: { margin: "0 20px 10px 20px" } },
                    _react2.default.createElement(
                        'div',
                        { style: {
                                marginBottom: "10px",
                                fontWeight: "700"
                            } },
                        '\u8BA2\u9605\u5B57\u6BB5\uFF1A'
                    ),
                    columns && _react2.default.createElement(
                        _yylibUi.YYCheckboxGroup,
                        { onChange: this.onCheckChange },
                        columns.map(function (item) {
                            return _react2.default.createElement(
                                _yylibUi.YYCheckbox,
                                { value: item.value },
                                item.name
                            );
                        })
                    )
                )
            ) : null
        );
    }
});
module.exports = SubsButton;